diff --git a/drupal7/sites/all/modules/nodeaccess/nodeaccess.module b/drupal7/sites/all/modules/nodeaccess/nodeaccess.module
index 781bac80..19335d20 100644
--- a/drupal7/sites/all/modules/nodeaccess/nodeaccess.module
+++ b/drupal7/sites/all/modules/nodeaccess/nodeaccess.module
@@ -848,60 +467,50 @@ function nodeaccess_grants_form_submit($form, &$form_state) {
   }
 }
 
+
 /**
  * Private function to submit the per-node grants table.
+ *
+ * @param array $form
+ * @param array &$form_state
  */
-function _nodeaccess_grants_form_submit($form, $form_state) {
+function _nodeaccess_grants_form_submit($form, &$form_state) {
   $form_values = &$form_state['values'];
-  global $user;
+
   $grants = array();
   $nid = $form_values['nid'];
   $node = node_load($nid);
+
   foreach (array('uid', 'rid') as $type) {
     $realm = 'nodeaccess_' . $type;
+
     if (isset($form_values[$type]) && is_array($form_values[$type])) {
       foreach ($form_values[$type] as $gid => $line) {
         $grant = array(
           'gid' => $gid,
           'realm' => $realm,
-          'grant_view' => empty($line['grant_view']) ? 0 : $line['grant_view'],
-          'grant_update' => empty($line['grant_update']) ? 0 : $line['grant_update'],
-          'grant_delete' => empty($line['grant_delete']) ? 0 : $line['grant_delete'],
+          'grant_view' => empty($line['grant_view']) ? 0 : 1,
+          'grant_update' => empty($line['grant_update']) ? 0 : 1,
+          'grant_delete' => empty($line['grant_delete']) ? 0 : 1,
         );
-        if ($grant['grant_view'] || $grant['grant_update'] || $grant['grant_delete']) {
-          $grants[] = $grant;
-        }
+        $grants[] = $grant;
       }
     }
-    node_access_write_grants($node, $grants, $realm);
-  }
-
-  // Save role and user grants to our own table.
-  db_delete('nodeaccess')
-  ->condition('nid', $nid)
-  ->execute();
-  foreach ($grants as $grant) {
-    $id = db_insert('nodeaccess')
-        ->fields(array(
-          'nid' => $nid,
-          'gid' => $grant['gid'],
-          'realm' => $grant['realm'],
-          'grant_view' => $grant['grant_view'],
-          'grant_update' => $grant['grant_update'],
-          'grant_delete' => $grant['grant_delete'],
-        ))
-    ->execute();
   }
+  nodeaccess_set_grants($node, $grants);
 }
 
 /**
  * Theme function for nodeaccess_grants_form.
+ *
+ * @param array $vars
+ *
+ * @return string
  */
-function theme_nodeaccess_grants_form($variables) {
+function theme_nodeaccess_grants_form($vars) {
   $output = '';
-  // @todo: Number of parameters in this theme function does not match number
-  // of parameters found in hook_theme.
-  $form = $variables['form'];
+
+  $form = $vars['form'];
   $rows = array();
   $allowed_roles = variable_get('nodeaccess-roles', array());
   $allowed_grants = variable_get('nodeaccess-grants', array());
@@ -918,28 +527,37 @@ function theme_nodeaccess_grants_form($variables) {
 
   // Roles table.
   $roles = element_children($form['rid']);
+
   if (count($roles) && count($allowed_roles)) {
     $header = array();
     $header[] = t('Role');
+
     if ($allowed_grants['view']) {
       $header[] = t('View');
     }
+
     if ($allowed_grants['edit']) {
       $header[] = t('Edit');
     }
+
     if ($allowed_grants['delete']) {
       $header[] = t('Delete');
     }
+
     foreach ($roles as $key) {
+
       if (isset($allowed_roles[$key]) && $allowed_roles[$key]) {
         $row = array();
         $row[] = $role_names[$key] . drupal_render($form['rid'][$key]['name']);
+
         if ($allowed_grants['view']) {
           $row[] = drupal_render($form['rid'][$key]['grant_view']);
         }
+
         if ($allowed_grants['edit']) {
           $row[] = drupal_render($form['rid'][$key]['grant_update']);
         }
+
         if ($allowed_grants['delete']) {
           $row[] = drupal_render($form['rid'][$key]['grant_delete']);
         }
@@ -960,6 +578,7 @@ function theme_nodeaccess_grants_form($variables) {
   // Users table.
   unset($rows);
   $users = element_children($form['uid']);
+
   if (count($users) > 0) {
     $header = array();
     $rows = array();
@@ -997,8 +616,14 @@ function theme_nodeaccess_grants_form($variables) {
   return $output;
 }
 
+
 /**
  * Implements hook_node_grants().
+ *
+ * @param Object $account
+ * @parap string $op
+ *
+ * @return array
  */
 function nodeaccess_node_grants($account, $op) {
   $roles = is_array($account->roles) ? array_keys($account->roles) : array(-1);
@@ -1011,17 +636,10 @@ function nodeaccess_node_grants($account, $op) {
 
 /**
  * Implements hook_node_update().
+ *
+ * @param Object $node
  */
 function nodeaccess_node_update($node) {
-  // Node author may have changed, overwrite old record.
-  $author_prefs = variable_get('nodeaccess_authors', array());
-  // Array is prepopulated with grant values.
-  $grant = $author_prefs[$node->type];
-  $grant['gid'] = $node->uid;
-  $grant['realm'] = 'nodeaccess_author';
-  $grants = array();
-  $grants[] = $grant;
-  node_access_write_grants($node, $grants, 'nodeaccess_author');
   if (module_exists('user_reference')) {
     $fields = variable_get('nodeaccess_' . $node->type . '_user_reference', array());
     foreach (array_keys($fields) as $field_name) {
@@ -1041,25 +659,26 @@ function nodeaccess_node_update($node) {
 
 /**
  * Implements hook_node_delete().
+ *
+ * @param Object $node
  */
 function nodeaccess_node_delete($node) {
   // Deleting node, delete related permissions.
-  db_delete('nodeaccess')
-  ->condition('nid', $node->nid)
-  ->execute();
-  foreach (array('uid', 'rid', 'author') as $type) {
-    $realm = 'nodeaccess_' . $type;
-    node_access_write_grants($node, array(), $realm);
-  }
+  nodeaccess_delete_grants($node);
 }
 
 /**
  * Implements hook_node_access_records().
+ *
+ * @param Object $node
+ *
+ * @return array|NULL
  */
 function nodeaccess_node_access_records($node) {
-  if (nodeaccess_disabling()) {
-    return;
+  if (nodeaccess_disabling() || !$node->status) {
+    return NULL;
   }
+
   // Need to find out if node has own grants or whether to use defaults.
   $default = variable_get('nodeaccess_' . $node->type, array());
 
@@ -1073,51 +692,25 @@ function nodeaccess_node_access_records($node) {
     'priority' => variable_get('nodeaccess-priority', 0),
   );
 
-  $result = db_query("SELECT count(*) FROM {nodeaccess} WHERE nid = :nid", array(':nid' => $node->nid))->fetchField();
-  if ($result < 1) {
-    // Node has no own grants, use defaults if published.
-    if ($node->status) {
-      $grants = $default;
-    }
-    else {
-      // Otherwise, check access to unpublished content for authenticated and
-      // anonymous users.
-      $role_perms = user_role_permissions(array(
-        DRUPAL_ANONYMOUS_RID => DRUPAL_ANONYMOUS_RID,
-        DRUPAL_AUTHENTICATED_RID => DRUPAL_AUTHENTICATED_RID,
-      ));
-      // Anonymous user setting.
-      $grants = array();
-      $grants[] = array(
-        'gid' => DRUPAL_ANONYMOUS_RID,
-        'grant_view' => isset($role_perms[DRUPAL_ANONYMOUS_RID]['bypass node access']) ?
-          intval($role_perms[DRUPAL_ANONYMOUS_RID]['bypass node access']) : 0,
-      );
-      // Authenticated user setting.
-      $grants[] = array(
-        'gid' => DRUPAL_AUTHENTICATED_RID,
-        'grant_view' => isset($role_perms[DRUPAL_AUTHENTICATED_RID]['bypass node access']) ?
-          intval($role_perms[DRUPAL_AUTHENTICATED_RID]['bypass node access']) : 0,
-      );
-    }
+  $query = db_select('nodeaccess', 'n')
+    ->fields('n', array('gid', 'realm', 'grant_view', 'grant_update', 'grant_delete'))
+    ->condition('nid', $node->nid, '=');
+  $result = $query->execute();
+  if (!$result->rowCount()) {
+    // Node has no own grants, use defaults.
+    $grants = $default;
   }
   else {
     // Node has own grants, use them.
-    $result = db_query("SELECT nid, gid, realm, grant_view, grant_update, grant_delete FROM {nodeaccess} WHERE nid = :nid", array(':nid' => $node->nid));
     $grants = array();
-    foreach ($result as $row) {
-      $grants[] = array(
-        'gid' => $row->gid,
-        'realm' => $row->realm,
-        'grant_view' => $row->grant_view,
-        'grant_update' => $row->grant_update,
-        'grant_delete' => $row->grant_delete,
-      );
+    while ($row = $result->fetchAssoc()) {
+      $grants[] = $row;
     }
   }
+
   // Apply author grants.
   $author_prefs = variable_get('nodeaccess_authors', array());
-  // Array is prepopulated with grant values.
+  // Array is pre-populated with grant values.
   $grant = $author_prefs[$node->type];
   $grant['gid'] = $node->uid;
   $grant['realm'] = 'nodeaccess_author';
@@ -1129,9 +722,11 @@ function nodeaccess_node_access_records($node) {
     // Merge missing default grant keys.
     $grants[$id] = $grants[$id] + $grant_defaults;
   }
+
   return $grants;
 }
 
+
 /**
  * Mark module to be in process of disabling.
  *
@@ -1139,17 +734,24 @@ function nodeaccess_node_access_records($node) {
  *
  * @param mixed $set
  *   A boolean set or NULL to not change status.
+ *
+ * @return bool
  */
 function nodeaccess_disabling($set = NULL) {
   static $disabling = FALSE;
+
   if ($set !== NULL) {
     $disabling = $set;
   }
+
   return $disabling;
 }
 
+
 /**
  * Implements hook_node_type_delete().
+ *
+ * @param Object $info
  */
 function nodeaccess_node_type_delete($info) {
   // Node type is being deleted, delete its preferences.
@@ -1159,8 +761,11 @@ function nodeaccess_node_type_delete($info) {
   variable_set('nodeaccess_authors', $author_prefs);
 }
 
+
 /**
  * Implements hook_node_type_update().
+ *
+ * @param Object $info
  */
 function nodeaccess_node_type_update($info) {
   // Node type has changed, move preferences to new type.
@@ -1179,55 +784,67 @@ function nodeaccess_node_type_update($info) {
   }
 }
 
+
 /**
  * Implements hook_node_type_insert().
+ *
+ * @param Object $info
  */
 function nodeaccess_node_type_insert($info) {
   // New node type, default to whatever is set for access content permission.
   $role_perms = user_role_permissions(array(1 => 1, 2 => 2));
-  $role_perms[1]['access content'] = isset($role_perms[1]['access content'])?
+  $role_perms[DRUPAL_ANONYMOUS_RID]['access content'] = isset($role_perms[1]['access content']) ?
                                       intval($role_perms[1]['access content']) : 0;
-  $role_perms[2]['access content'] = isset($role_perms[2]['access content'])?
+  $role_perms[DRUPAL_AUTHENTICATED_RID]['access content'] = isset($role_perms[2]['access content']) ?
                                       intval($role_perms[2]['access content']) : 0;
   $grants[] = array(
-    'gid' => 1,
+    'gid' => DRUPAL_ANONYMOUS_RID,
     'realm' => 'nodeaccess_rid',
-    'grant_view' => $role_perms[1]['access content'],
+    'grant_view' => $role_perms[DRUPAL_ANONYMOUS_RID]['access content'],
     'grant_update' => 0,
     'grant_delete' => 0,
   );
   $grants[] = array(
-    'gid' => 2,
+    'gid' => DRUPAL_AUTHENTICATED_RID,
     'realm' => 'nodeaccess_rid',
-    'grant_view' => $role_perms[1]['access content'],
+    'grant_view' => $role_perms[DRUPAL_AUTHENTICATED_RID]['access content'],
     'grant_update' => 0,
     'grant_delete' => 0,
   );
   variable_set('nodeaccess_' . $info->type, $grants);
-  // Add all permissions for author.
+
+  // Add permissions for author.
   $author_prefs = variable_get('nodeaccess_authors', array());
   $author_prefs[$info->type] = array(
     'grant_view' => 0,
     'grant_update' => 0,
     'grant_delete' => 0,
   );
+
   variable_set('nodeaccess_authors', $author_prefs);
   node_access_needs_rebuild(TRUE);
 }
 
+
 /**
  * Retrieve role aliases.
  *
- * @return array or role aliases indexed by rid.
+ * @return array
+ *  Role aliases indexed by rid.
  */
 function nodeaccess_get_role_aliases() {
   $aliases = array();
-  $sql = 'SELECT r.rid, r.name, a.name AS alias, a.weight
-    FROM {role} r
-    LEFT JOIN {nodeaccess_role_alias} a ON r.rid = a.rid
-    ORDER BY a.weight, r.weight, a.name, r.name';
-  $results = db_query($sql);
-  foreach ($results as $a) {
+  $query = db_select('role', 'r');
+  $query->join('nodeaccess_role_alias', 'a', 'r.rid = a.rid');
+  $query->fields('r', array('rid', 'name'));
+  $query->addField('a', 'name', 'alias');
+  $query->addField('a', 'weight');
+  $query->orderBy('a.weight');
+  $query->orderBy('r.weight');
+  $query->orderBy('a.name');
+  $query->orderBy('r.name');
+  $result = $query->execute();
+  while($a = $result->fetch()) {
     $aliases[$a->rid]['name'] = $a->name;
     $aliases[$a->rid]['alias'] = $a->alias;
     $aliases[$a->rid]['weight'] = $a->weight;
@@ -1235,7 +852,6 @@ function nodeaccess_get_role_aliases() {
   return $aliases;
 }
 
-
 /**
  * Save a role alias.
  *
@@ -1253,15 +869,16 @@ function nodeaccess_save_role_aliases($edit) {
       ))->execute();
     }
   }
-
   return;
 }
 
 /**
  * Insert userreference grants from a node.
+ *
+ * @param Object $node
  */
 function nodeaccess_insert_user_reference($node) {
-  $form_values = _nodeaccess_get_grants($node);
+  $form_values = nodeaccess_get_grants($node);
   // Now, append or overwrite the uid with what was specified in the user
   // reference field.
   $fields = variable_get('nodeaccess_' . $node->type . '_user_reference', array());
@@ -1289,9 +906,11 @@ function nodeaccess_insert_user_reference($node) {
 
 /**
  * Delete all userreference user grants from a node.
+ *
+ * @param Object $node
  */
 function nodeaccess_delete_user_reference($node) {
-  $form_values = _nodeaccess_get_grants($node);
+  $form_values = nodeaccess_get_grants($node);
   // Now, append or overwrite the uid with what was specified in the user
   // reference field.
   $fields = variable_get('nodeaccess_' . $node->type . '_user_reference', array());
@@ -1304,45 +923,198 @@ function nodeaccess_delete_user_reference($node) {
   }
   $form_values['nid'] = $node->nid;
   $form_state = array('values' => $form_values);
+
   _nodeaccess_grants_form_submit(NULL, $form_state);
 }
 
 /**
  * Return the grants applied to a node object used for Grant form.
  *
+ * @param Object $node
+ *
  * @return array
  *   An array of grants with keys 'rid' for roles and 'uid' for users.
  */
-function _nodeaccess_get_grants($node) {
+function nodeaccess_get_grants($node) {
   $grants = array();
-  // Load all roles.
-  $result = db_query("SELECT r.rid, nra.name, na.grant_view, na.grant_update, na.grant_delete FROM {role} r LEFT JOIN {nodeaccess_role_alias} nra ON r.rid = nra.rid LEFT JOIN {node_access} na ON r.rid = na.gid AND na.realm = :realm AND na.nid = :nid ORDER BY nra.weight, nra.name",
-    array(
-      ':realm' => 'nodeaccess_rid',
-      ':nid' => $node->nid,
-    ));
-  foreach ($result as $grant) {
-    $grants['rid'][$grant->rid] = array(
-      'name' => $grant->name,
-      'grant_view' => (boolean) $grant->grant_view,
-      'grant_update' => (boolean) $grant->grant_update,
-      'grant_delete' => (boolean) $grant->grant_delete,
-    );
+
+  // Load grants by roles.
+  $query = db_select('nodeaccess', 'na');
+  $query->join('role', 'r', 'r.rid = na.gid');
+  $query->join('nodeaccess_role_alias', 'nra', 'nra.rid = r.rid');
+  $query->fields('r', array('rid', 'name'));
+  $query->fields('na', array('grant_view', 'grant_update', 'grant_delete'));
+  $query->condition('na.realm', 'nodeaccess_rid', '=');
+  $query->condition('na.nid', $node->nid, '=');
+  $query->orderBy('nra.weight');
+  $query->orderBy('nra.name');
+  $result = $query->execute();
+
+  while ($grant = $result->fetch()) {
+    if ($grant->name) {
+      $grants['rid'][$grant->rid] = array(
+        'name' => $grant->name,
+        'grant_view' => (bool) $grant->grant_view,
+        'grant_update' => (bool) $grant->grant_update,
+        'grant_delete' => (bool) $grant->grant_delete,
+      );
+    }
   }
-  // Load users from node_access.
-  $result = db_query("SELECT uid, name, grant_view, grant_update, grant_delete FROM {node_access} LEFT JOIN {users} ON uid = gid WHERE nid = :nid AND realm = :realm ORDER BY name",
-    array(
-      ':nid' => $node->nid,
-      ':realm' => 'nodeaccess_uid',
-    ));
-  foreach ($result as $account) {
+  // Load grants by users
+  $query = db_select('node_access', 'na');
+  $query->join('users', 'u', 'u.uid = na.gid');
+  $query->fields('u', array('uid', 'name'));
+  $query->fields('na', array('grant_view', 'grant_update', 'grant_delete'));
+  $query->condition('na.nid', $node->nid, '=');
+  $query->condition('na.realm', 'nodeaccess_uid', '=');
+  $query->orderBy('name');
+  $result = $query->execute();
+
+  while ($account = $result->fetch()) {
     $grants['uid'][$account->uid] = array(
       'name' => $account->name,
-      'keep' => 1,
-      'grant_view' => $account->grant_view,
-      'grant_update' => $account->grant_update,
-      'grant_delete' => $account->grant_delete,
+      'keep' => TRUE,
+      'grant_view' => (bool) $account->grant_view,
+      'grant_update' => (bool) $account->grant_update,
+      'grant_delete' => (bool) $account->grant_delete,
     );
   }
   return $grants;
 }
+
+/**
+ * Set all grants for a node to nodeaccess table and acquire them.
+ *
+ * @param $node
+ *   node object the grants are being applied to.
+ * @param array $grants
+ *   array of grants as defined (@see nodeaccess_save_grant).
+ */
+function nodeaccess_set_grants($node, $grants = array()) {
+  // Allow other modules to edit all grants for array.
+  drupal_alter('nodeaccess_grants', $grants, $node);
+
+  nodeaccess_delete_grants($node);
+
+  if (count($grants)) {
+    foreach ($grants as $grant) {
+      // Allow other modules to edit single grants.
+      drupal_alter('nodeaccess_grant', $grant, $node);
+      nodeaccess_save_grant($node, $grant);
+    }
+  }
+
+  node_access_acquire_grants($node);
+}
+
+
+/**
+ * Delete all grants from nodeaccess table for this node.
+ *
+ * @param $node
+ *   node object whose grants are being revoked.
+ */
+function nodeaccess_delete_grants($node) {
+  try {
+    db_delete('nodeaccess')
+      ->condition('nid', $node->nid)
+      ->execute();
+
+    node_access_acquire_grants($node);
+  }
+  catch (Exception $e) {
+    drupal_set_message(t("Database error has occurred while clearing nodeaccess table."), 'error');
+    watchdog('nodeaccess', 'Database error: @message.', array('@message' => $e->getMessage()), WATCHDOG_ERROR);
+  }
+}
+
+/**
+ * Revoke all custom grants from nodeaccess table for this node.  Essentially
+ * reset the grants to their default state (by node type).
+ *
+ * @param $node
+ *   node object whose grants are being revoked.
+ */
+function nodeaccess_revoke_grants($node) {
+  nodeaccess_delete_grants($node);
+  node_access_acquire_grants($node);
+}
+
+/**
+ * Save the grant settings/options for the node.
+ *
+ * @param $node
+ *   node object the grant is being applied to.
+ * @param array $grant
+ *   array(
+ *    'gid' => (int) gid for realm,
+ *    'realm' => (string) what realm the access grant belongs to (ex: nodeaccess_rid).
+ *    'grant_view' => (int) view access being granted,
+ *    'grant_update' => (int) update access being granted,
+ *    'grant_delete' => (int) delete access being granted,
+ *  )
+ */
+function nodeaccess_save_grant($node, $grant) {
+  // Save role and user grants to our own table.
+  try {
+    db_insert('nodeaccess')
+      ->fields(array(
+        'nid' => $node->nid,
+        'gid' => $grant['gid'],
+        'realm' => $grant['realm'],
+        'grant_view' => (int) $grant['grant_view'],
+        'grant_update' => (int) $grant['grant_update'],
+        'grant_delete' => (int) $grant['grant_delete'],
+      ))
+      ->execute();
+  }
+  catch (Exception $e) {
+    drupal_set_message(t("Database error has occurred while saving to nodeaccess table."), 'error');
+    watchdog('nodeaccess', 'Database error: @message.', array('@message' => $e->getMessage()), WATCHDOG_ERROR);
+  }
+}
+
+/**
+ * Add the grant tab to the specified node type.
+ *
+ * @param string $type
+ *   The node type we are adding the grant tab for.
+ */
+function nodeaccess_add_type_grant($type) {
+  $grants = variable_get('nodeaccess-types', array());
+  $grants[$type] = TRUE;
+
+  nodeaccess_set_type_grants($grants);
+}
+
+/**
+ * Delete the grant tab for specified node type.
+ *
+ * @param string $type
+ *   The node type we are removing the grant tab from.
+ */
+function nodeaccess_delete_type_grant($type) {
+  $grants = variable_get('nodeaccess-types', array());
+
+  if (isset($grants[$type])) {
+    unset($grants[$type]);
+  }
+
+  nodeaccess_set_type_grants($grants);
+}
+
+/**
+ * Set the grant tab settings for all node types.
+ *
+ * @param array $types
+ *   The types that will have the grant tab appear.
+ *
+ */
+function nodeaccess_set_type_grants($types = array()) {
+  if (!is_array($types)) {
+    return;
+  }
+
+  variable_set('nodeaccess-types', $types);
+  node_access_needs_rebuild(TRUE);
+}
diff --git a/drupal7/sites/all/modules/nodeaccess/tests/nodeaccess_grant.test b/drupal7/sites/all/modules/nodeaccess/tests/nodeaccess_grant.test
new file mode 100644
index 00000000..f4b04a2f
--- /dev/null
+++ b/drupal7/sites/all/modules/nodeaccess/tests/nodeaccess_grant.test
@@ -0,0 +1,62 @@
+<?php
+
+/**
+ * @file
+ * Tests for the nodeaccess module.
+ */
+
+/**
+ * Tests the functionality of the nodeaccess module.
+ */
+class NodeaccesssGrantTabTestCase extends DrupalWebTestCase {
+
+  /**
+   * Enable the nodeaccess module.
+   */
+  public function setUp() {
+    parent::setUp('nodeaccess');
+  }
+
+  /**
+   * Provide some information about this test case.
+   */
+  public static function getInfo() {
+    return array(
+      'name' => 'Nodeaccess Grant Tab visibility',
+      'description' => 'Tests whether the Grant tab appears correctly..',
+      'group' => 'Nodeaccess',
+    );
+  }
+
+  /**
+   * Make sure the 'Grant' tab is available from the node view when appropriate.
+   * @test
+   */
+  public function testGrantTabVisbility() {
+    // Create a test user, and a node with nodeaccess enabled for its type.
+    $user = $this->drupalCreateUser(array('grant node permissions'));
+    $node = $this->drupalCreateNode();
+    nodeaccess_add_type_grant($node->type);
+
+    // First, before logging in, we shouldn't see a link.
+    $this->drupalGet("node/{$node->nid}");
+    $this->assertNoLinkByHref("node/{$node->nid}/grant");
+
+    // Log in and the grant tab should appear.
+    $this->drupalLogin($user);
+    $this->drupalGet("node/{$node->nid}");
+    $this->assertLinkByHref("node/{$node->nid}/grant");
+
+    // Disable nodeaccess for this content type, and the tab should be gone.
+    nodeaccess_delete_type_grant($node->type);
+    $this->drupalGet("node/{$node->nid}");
+    $this->assertNoLinkByHref("node/{$node->nid}/grant");
+
+    // Confirm that the anonymous user still doesn't see the grant tab.
+    $this->drupalLogout();
+    $this->drupalGet("node/{$node->nid}");
+    $this->assertNoLinkByHref("node/{$node->nid}/grant");
+
+  }
+
+}
diff --git a/drupal7/sites/all/modules/nodeaccess/tests/nodeaccess_publish.test b/drupal7/sites/all/modules/nodeaccess/tests/nodeaccess_publish.test
new file mode 100644
index 00000000..c6048d03
--- /dev/null
+++ b/drupal7/sites/all/modules/nodeaccess/tests/nodeaccess_publish.test
@@ -0,0 +1,178 @@
+<?php
+
+/**
+ * @file
+ * Tests for the nodeaccess module.
+ */
+
+/**
+ * Tests the functionality of the nodeaccess module.
+ */
+class NodeaccesssPublishTestCase extends DrupalWebTestCase {
+
+  // Nodes.
+  protected $authored_node;
+  protected $published_node;
+  protected $unpublished_node;
+
+  // Users.
+  protected $admin_user;
+  protected $author_user;
+  protected $basic_user;
+
+  // Default Grant.
+  protected $grant;
+
+  /**
+   * Enable the nodeaccess module. Add type grant for pages. Rebuild perms.
+   */
+  public function setUp() {
+    parent::setUp('nodeaccess');
+
+    user_role_grant_permissions(DRUPAL_ANONYMOUS_RID, array('access content'));
+
+    nodeaccess_add_type_grant('page');
+
+    // Let's create a sample authenticated user with basic permissions.
+    $this->basic_user = $this->drupalCreateUser(array('access content'));
+
+    // Let's create a sample author-type user.
+    $this->author_user = $this->drupalCreateUser(array('access content', 'view own unpublished content'));
+
+    // Let's create a more admin-type user.
+    $this->admin_user = $this->drupalCreateUser(array('access content', 'bypass node access'));
+
+    // Create a published page node, authored by admin.
+    $this->published_node = $this->drupalCreateNode(array('type' => 'page', 'uid' => 1));
+
+    // Create an unpublished page node, authored by admin.
+    $this->unpublished_node = $this->drupalCreateNode(array('type' => 'page', 'uid' => 1, 'status' => 0));
+
+    // Create an unpublished page node, authored by author.
+    $this->authored_node = $this->drupalCreateNode(array('type' => 'page', 'uid' => $this->author_user->uid, 'status' => 0));
+
+    $this->grant = array(
+      array(
+        'gid' => DRUPAL_ANONYMOUS_RID,
+        'realm' => 'nodeaccess_rid',
+        'grant_view' => 1,
+        'grant_update' => 0,
+        'grant_delete' => 0,
+      ),
+      array(
+        'gid' => DRUPAL_AUTHENTICATED_RID,
+        'realm' => 'nodeaccess_rid',
+        'grant_view' => 1,
+        'grant_update' => 0,
+        'grant_delete' => 0,
+      ),
+    );
+
+    node_access_rebuild();
+  }
+
+  /**
+   * Provide some information about this test case.
+   */
+  public static function getInfo() {
+    return array(
+      'name' => 'Nodeaccess node status based tests.',
+      'description' => 'Tests nodes are correctly hidden based on node published status.',
+      'group' => 'Nodeaccess',
+    );
+  }
+
+  /**
+   * Test standard, published node visibility.
+   */
+  public function testPublishedView() {
+
+    nodeaccess_set_grants($this->published_node, $this->grant);
+
+    // Baseline, should be visible by all users, including anon.
+    $this->drupalGet("node/{$this->published_node->nid}");
+    $this->assertResponse(200, 'Anonymous user is allowed to view the content.');
+
+    // Authenticated User
+    $this->drupalLogin($this->basic_user);
+    $this->drupalGet("node/{$this->published_node->nid}");
+    $this->assertResponse(200, 'Authenticated user is allowed to view the content.');
+    $this->drupalLogout();
+
+    // Author User
+    $this->drupalLogin($this->author_user);
+    $this->drupalGet("node/{$this->published_node->nid}");
+    $this->assertResponse(200, 'Author user is allowed to view the content.');
+    $this->drupalLogout();
+
+    // Admin User
+    $this->drupalLogin($this->admin_user);
+    $this->drupalGet("node/{$this->published_node->nid}");
+    $this->assertResponse(200, 'Admin user is allowed to view the content.');
+    $this->drupalLogout();
+
+  }
+
+  /**
+   * Test unpublished node visibility.
+   */
+  public function testUnpublishedView() {
+    nodeaccess_set_grants($this->unpublished_node, $this->grant);
+
+    // Anonymous users should NOT see the content.
+    $this->drupalGet("node/{$this->unpublished_node->nid}");
+    $this->assertResponse(403, 'Anonymous user is not allowed to view the unpublished content.');
+
+    // Authenticated User, should NOT see content.
+    $this->drupalLogin($this->basic_user);
+    $this->drupalGet("node/{$this->unpublished_node->nid}");
+    $this->assertResponse(403, 'Authenticated user is not allowed to view the unpublished content.');
+    $this->drupalLogout();
+
+    // Author User, should NOT see the content, not author of this node.
+    $this->drupalLogin($this->author_user);
+    $this->drupalGet("node/{$this->unpublished_node->nid}");
+    $this->assertResponse(403, 'Author user is not allowed to view the unpublished content.');
+    $this->drupalLogout();
+
+    // Admin User should see content, has administer content permission.
+    $this->drupalLogin($this->admin_user);
+    $this->drupalGet("node/{$this->unpublished_node->nid}");
+    $this->assertResponse(200, 'Admin user is allowed to view the unpublished content (bypass).');
+    $this->drupalLogout();
+
+  }
+
+/**
+   * Test unpublished node visibility.
+   */
+  public function testAuthoredView() {
+    nodeaccess_set_grants($this->authored_node, $this->grant);
+
+    // Anonymous users should NOT see the content.
+    $this->drupalGet("node/{$this->authored_node->nid}");
+    $this->assertResponse(403, 'Anonymous user is not allowed to view the unpublished content.');
+
+    // Authenticated User, should NOT see content.
+    $this->drupalLogin($this->basic_user);
+    $this->drupalGet("node/{$this->authored_node->nid}");
+    $this->assertResponse(403, 'Authenticated user is not allowed to view the unpublished content.');
+    $this->drupalLogout();
+
+    // Author User, should NOT see the content, not author of this node.
+    $this->drupalLogin($this->author_user);
+    $this->drupalGet("node/{$this->authored_node->nid}");
+    $this->assertResponse(200, 'Author user is allowed to view their own unpublished content.');
+    $this->drupalLogout();
+
+    // Admin User should see content, has administer content permission.
+    $this->drupalLogin($this->admin_user);
+    $this->drupalGet("node/{$this->authored_node->nid}");
+    $this->assertResponse(200, 'Admin user is allowed to view the unpublished content (bypass).');
+    $this->drupalLogout();
+
+  }
+
+
+
+}
